//Include file for 48KHz to 44.1KHz.  Greatest Common Denominator (GCD) = 160/147.

#define HALFB 0						// Half band flag
#define NUPST 0						// Number of up stages
#define PVTFL 1						// Pivot flag
#define NDWNS 2						// Number of down stages
#define STAGE 3						// Number of total stages 
#define NINPS 160					// Number of imput samples (Should be a even multiple of the GCD)
#define NOUTS 147					// Number of output samples (Should be the same multiple as above of the GCD)

#define INTP1 147
#define DOWN1 16
#define LENG1 49					// LENG1 = length of stage filter
#define PLEN1 1						// PLEN1 = MLEN1/INTP1 (polyphase length)
#define MLEN1 147					// MLEN1 = LENG1 + enough to make even length for polyphase
#define SHFT1 0
#define NINP1 NINPS					// NINPS (...or NOUTS) = 160
#define SZIN1 (NINP1 + ((LENG1-1)/INTP1) + 1) // 160 + 48/147 + 1 = 161

#define INTP2 1
#define DOWN2 5
#define LENG2 27					// LENG2 = length of stage filter
#define PLEN2 27					// PLEN2 = MLEN2/INTP2 (polyphase length)
#define MLEN2 27					// MLEN2 = LENG2 + enough to make even length for polyphase
#define SHFT2 -2
#define NINP2 ((NINP1*INTP1)/DOWN1)	// (NINPx*INTPx)/DOWNx = 160*147/16 = 1470
#define SZIN2 (NINP2 + ((LENG2-1)/INTP2) + 1) // 1470 + 26/1 + 1 = 1497

#define INTP3 1
#define DOWN3 2
#define LENG3 223					// LENG3 = length of stage filter
#define PLEN3 223					// PLEN2 = MLEN2/INTP2 (polyphase length)
#define MLEN3 223					// MLEN2 = LENG2 + enough to make even length for polyphase
#define SHFT3 2
#define NINP3 ((NINP2*INTP2)/DOWN2)	// (NINPx*INTPx)/DOWNx 1470*1/5 = 294
#define SZIN3 (NINP3 + ((LENG3-1)/INTP3) + 1) // 294 + 222/1 + 1 = 517

#define NINP4 ((NINP3*INTP3)/DOWN3)	// (NINPx*INTPx)/DOWNx = 294*1/2 = 147
#define SZIN4 NINP4 + 1  			// for last decimation stage only = 148

#define OFFS1 (LENG1-1)/(2*DOWN1)	//  
#define OFFS2 (LENG2-1)/(2*DOWN2)	//  
#define OFFS3 (LENG3-1)/(2*DOWN3)	//  


#if OFFS3 < 1
#define OF2S3 1
#else
#define OF2S3 OFFS3
#endif

#define TOFS1 OFFS1							// 
#define TOFS2 ((INTP2*TOFS1)/DOWN2 + OFFS2)	//  
#define TOFS3 ((INTP3*TOFS2)/DOWN3 + OF2S3)	//  

//#define DOFS3 (NOUTS-TOFS3)		// Used to strip filter delays off buffers

#define DOFS3 NOUTS
